<?php
class apply_request {
  public $name; // string
  public $valid_applicant_confirmation; // boolean
  public $based_on_person_name; // boolean
  public $person_name_registration_id; // int
  public $person_name_registration_number; // string
  public $domain_name_holder_company_type; // int
  public $domain_name_holder_business_id; // string
  public $domain_name_holder_person_id; // string
  public $electronic_notification_approval; // boolean
  public $data_publishing_approval; // boolean
  public $nameservers; // ArrayOfnameserver
  public $contacts; // ArrayOfcontact
  public $context; // context
  public $domain_validity_period_in_months; // int
}

class nameserver {
  public $name; // string
  public $ipaddress; // string
}

class contact {
  public $type; // int
  public $company; // string
  public $first_names; // ArrayOfstring
  public $last_name; // string
  public $postal_address; // string
  public $postal_code; // string
  public $postal_office; // string
  public $phone; // string
  public $email; // string
  public $language_code; // string
  public $department; // string
}

class context {
  public $user_name; // string
  public $mac; // string
  public $timestamp; // dateTime
}

class apply_response {
  public $code; // boolean
  public $timestamp; // dateTime
  public $webdomain_validation_errors; // ArrayOferror_message
  public $contact_validation_errors; // ArrayOferror_message
  public $nameserver_validation_errors; // ArrayOferror_message
  public $nameserver_technical_errors; // ArrayOferror_message
}

class error_message {
  public $description; // string
  public $code; // string
}

class change_nameservers_request {
  public $webdomain_name; // string
  public $authorization_key; // string
  public $nameservers; // ArrayOfnameserver
  public $context; // context
}

class change_nameservers_response {
  public $code; // boolean
  public $timestamp; // dateTime
  public $webdomain_validation_errors; // ArrayOferror_message
  public $nameserver_validation_errors; // ArrayOferror_message
  public $nameserver_technical_errors; // ArrayOferror_message
}

class remove_nameservers_request {
  public $webdomain_name; // string
  public $context; // context
}

class remove_nameservers_response {
  public $code; // boolean
  public $timestamp; // dateTime
  public $webdomain_validation_errors; // ArrayOferror_message
}

class renew_request {
  public $webdomain_name; // string
  public $authorization_key; // string
  public $context; // context
  public $domain_validity_period_in_months; // int
}

class renew_response {
  public $code; // boolean
  public $timestamp; // dateTime
  public $webdomain_validation_errors; // ArrayOferror_message
}

class Apply {
  public $webDomainRequest; // apply_request
}

class ApplyResponse {
  public $ApplyResult; // apply_response
}

class Dummy {
  public $webDomain; // apply_request
  public $nameServer; // nameserver
  public $contract; // contact
  public $errormessage; // error_message
}

class DummyResponse {
}

class ChangeNameServers {
  public $changeNameServerRequest; // change_nameservers_request
}

class ChangeNameServersResponse {
  public $ChangeNameServersResult; // change_nameservers_response
}

class RemoveNameServers {
  public $removeNameServerRequest; // remove_nameservers_request
}

class RemoveNameServersResponse {
  public $RemoveNameServersResult; // remove_nameservers_response
}

class Renew {
  public $renewRequest; // renew_request
}

class RenewResponse {
  public $RenewResult; // renew_response
}

class Ping {
}

class PingResponse {
  public $PingResult; // string
}

class char {
}

class duration {
}

class guid {
}


/**
 * DomainNameWS class
 * 
 *  
 * 
 * @author    {author}
 * @copyright {copyright}
 * @package   {package}
 */
class DomainNameWS extends SoapClient {

  private static $classmap = array(
                                    'apply_request' => 'apply_request',
                                    'nameserver' => 'nameserver',
                                    'contact' => 'contact',
                                    'context' => 'context',
                                    'apply_response' => 'apply_response',
                                    'error_message' => 'error_message',
                                    'change_nameservers_request' => 'change_nameservers_request',
                                    'change_nameservers_response' => 'change_nameservers_response',
                                    'remove_nameservers_request' => 'remove_nameservers_request',
                                    'remove_nameservers_response' => 'remove_nameservers_response',
                                    'renew_request' => 'renew_request',
                                    'renew_response' => 'renew_response',
                                    'Apply' => 'Apply',
                                    'ApplyResponse' => 'ApplyResponse',
                                    'Dummy' => 'Dummy',
                                    'DummyResponse' => 'DummyResponse',
                                    'ChangeNameServers' => 'ChangeNameServers',
                                    'ChangeNameServersResponse' => 'ChangeNameServersResponse',
                                    'RemoveNameServers' => 'RemoveNameServers',
                                    'RemoveNameServersResponse' => 'RemoveNameServersResponse',
                                    'Renew' => 'Renew',
                                    'RenewResponse' => 'RenewResponse',
                                    'Ping' => 'Ping',
                                    'PingResponse' => 'PingResponse',
                                    'char' => 'char',
                                    'duration' => 'duration',
                                    'guid' => 'guid',
                                   );

  public function DomainNameWS($wsdl = "https://domainws.ficora.fi/fidomaintest/DomainNameWS_FicoraDomainNameWS.svc?wsdl", $options = array()) {
    foreach(self::$classmap as $key => $value) {
      if(!isset($options['classmap'][$key])) {
        $options['classmap'][$key] = $value;
      }
    }
    parent::__construct($wsdl, $options);
  }

  /**
   *  
   *
   * @param Apply $parameters
   * @return ApplyResponse
   */
  public function Apply(Apply $parameters) {
    return $this->__soapCall('Apply', array($parameters),       array(
            'uri' => 'http://domainws.ficora.fi',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param Dummy $parameters
   * @return DummyResponse
   */
  public function Dummy(Dummy $parameters) {
    return $this->__soapCall('Dummy', array($parameters),       array(
            'uri' => 'http://domainws.ficora.fi',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param ChangeNameServers $parameters
   * @return ChangeNameServersResponse
   */
  public function ChangeNameServers(ChangeNameServers $parameters) {
    return $this->__soapCall('ChangeNameServers', array($parameters),       array(
            'uri' => 'http://domainws.ficora.fi',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param RemoveNameServers $parameters
   * @return RemoveNameServersResponse
   */
  public function RemoveNameServers(RemoveNameServers $parameters) {
    return $this->__soapCall('RemoveNameServers', array($parameters),       array(
            'uri' => 'http://domainws.ficora.fi',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param Renew $parameters
   * @return RenewResponse
   */
  public function Renew(Renew $parameters) {
    return $this->__soapCall('Renew', array($parameters),       array(
            'uri' => 'http://domainws.ficora.fi',
            'soapaction' => ''
           )
      );
  }

  /**
   *  
   *
   * @param Ping $parameters
   * @return PingResponse
   */
  public function Ping(Ping $parameters) {
    return $this->__soapCall('Ping', array($parameters),       array(
            'uri' => 'http://domainws.ficora.fi',
            'soapaction' => ''
           )
      );
  }

}

?>
