<?
$full_home_path = dirname(__FILE__);
require_once($full_home_path."/_rootload.php");

# batch_timestamp - время совершения транзакции
# currency_id - валюта транзакции ( Примечание: представляет собой буквенный, трех-значный код в соответствии с ISO 4217 )
# amount - сумма транзакции
# payment_method - метод совершения транзакции (возможные значения: cc - банковская карта, test - совершена без реального процессинга карты)
# order_id - номер заказа в системе webpay.by
# site_order_id - номер (имя) заказа, присвоенное магазином
# transaction_id - номер транзакции
# payment_type - тип транзакции
# rrn - номер транзакции в системе Visa/MasterCard
# wsb_signature - электронная подпись *

$input = '';
foreach ($_POST as $field=>$value) { 
	$input .= $field." ".$value."\n";
}
$input = "Входящие параметры:\n\n$input";

if (getenv("REQUEST_METHOD") != "POST") { 
	mconnect();

	$manager_email=GetSetting('manager_email');

	$msg = "С IP-адреса $ip произошло обращение к скрипту online_webpay.php по GET-протоколу.\n\nБудьте внимательны, т.к. возможно кто-то пытается взломать систему.\n\n$input\n\n--\nRootPanel";
	$subject = "Возможная попытка взлома билинга [WebPay]";

	$admEmails=GetAdminEmailsWhereTrueParam("senderror");
	if (count($admEmails) > 0) {
		WriteMailLog($subject,$msg);
	}
	while (list($i,$em) = @each($admEmails)) {
		sendmail($em,'',$manager_email,$subject,$msg);
	}

	mclose();
	exit; 
}

mconnect();
EnableLanguages();

$bill = GetBillById(intval($site_order_id));

$webpay_storeid=GetSetting("webpay_storeid");
$webpay_secret=GetSetting("webpay_secret");

$hash = md5($batch_timestamp.$currency_id.$amount.$payment_method.$order_id.$site_order_id.$transaction_id.$payment_type.$rrn.$webpay_secret);

if (!$site_order_id) { $error_msg = "Отсутствует номер счета биллинг-системы."; }
else if (!$bill->id) { $error_msg = "Счет # $site_order_id не найден."; }
else if ($amount != $bill->merchantmoney) { $error_msg = "Неправильная сумма оплаты."; }
else if ($currency_id != "BYR") { $error_msg = "Неправильная валюта платежа."; }
else if ($payment_method != "cc") { $error_msg = "Неправильный метод совершения платежа (без реального процессинга карты)."; }
else if ($payment_type != "1" and $payment_type != "4") { $error_msg = "Неправильный тип транзакции."; }
else if ($hash != $wsb_signature) { $error_msg = "Неправильная контрольная подпись."; }
else {
	MakeBillPayed($bill->id,1,"WebPay Merchant ($transaction_id)");
	mclose();
	exit;
}

$manager_email=GetSetting('manager_email');

$msg = "Автоматическая оплата через WebPay Merchant отклонена биллинг-системой по причине:\n\n$error_msg\n\n$input\n\nSHA1 by RootPanel: ".$hash."\n\nIP: $ip\n\n--\nRootPanel";
$subject = "Ошибка автоматической оплаты [WebPay]";

$admEmails=GetAdminEmailsWhereTrueParam("senderror");
if (count($admEmails) > 0) {
	WriteMailLog($subject,$msg);
}
while (list($i,$em) = @each($admEmails)) {
	sendmail($em,'',$manager_email,$subject,$msg);
}
mclose();

?>